#ifndef MPO_FILE_STREAM_H
#define MPO_FILE_STREAM_H

#include "mpo_stream.h"
#include "mpo_fileio.h"

class EXPORT_ME MpoFileStream : public IBlockingStream, public MpoDeleter
{
public:
	static blocking_sharedptr GetInstance(const char *filename, open_type flags);

	static blocking_sharedptr GetInstance(const wstring &filename, open_type flags);

	size_t Read(void *buf, size_t stBytesToRead);

	size_t Write(const void *buf, size_t stBytesToWrite);

	bool Seek(MPO_INT64 i64Offset, seek_type origin);

	// returns length of stream
	MPO_UINT64 GetLength();

	// returns current position within stream
	MPO_UINT64 GetPosition();

	bool CanRead();

	bool CanWrite();

	bool CanSeek();

private:
	MpoFileStream();
	~MpoFileStream();

	void DeleteInstance();

	mpo_io *m_io;

};

#endif // MPO_FILE_STREAM_H
